org #3800
;run #8000
txt_output equ #bb5a
lionlogo_org equ #f1d0


initscreen:
call #bc14
ld hl,outlist1
call setscreen
call chord

ld d,parts/#100
;ld iy,&F00F

ld bc,silvuppo0
call drawlogo
call wait
call drawlogo
call wait
call drawlogo


	ld hl,lioncompressed
	ld de,lion
	decomp_loop:
	ld b,1 ;standard amount
	ld a,(hl)
	cp 2
	jr z,end_decompress ;a=2 means eol
	cp b
	jr nz,write_to_de ;a=1 means next is amount of zeroes -1
		inc hl
		ld b,(hl) ;get amount (-1)
		xor a ;zero
	write_to_de:
		ld (de),a
		inc de
		djnz write_to_de
	inc hl
	jr decomp_loop
end_decompress:

ld ixh,65
ld hl,Lion
	shift_window_up:
		ld de,lionlogo_org+#200
		ld bc,32
		ldir
		push hl
		ld hl,lionlogo_org+#800
		ld ixl,63
		shiftline:
		ld d,h:ld e,l
		ld bc,#800:add hl,bc
		jr nc,nocarry
			ld bc,#c040:add hl,bc
		nocarry:
		ld bc,32
		ldir
		ld bc,32:sbc hl,bc

	dec ixl
	jr nz,shiftline
	dec ixh
pop hl
jr nz,shift_window_up
call wait
call wait+2

ld hl,warning
ld bc,end_string-warning
	prloop:
	ld a,(hl):inc hl
	call txt_output
	dec bc:ld a,b:or c
	jr nz, prloop

call #bb06
call #bc14


 ld c,7
 LD HL,&b0ff
 LD DE,&0040
 call &bcce



ld hl,outlist2
call setscreen

ld a,"3":ld hl,#c000
call load_files

ld a,"1":ld hl,#40
call load_files

ld a,"2":ld hl,#4000
call load_files


di
ld hl,#4000
ld de,#8000
ld bc,#4000
ldir

ld hl,#c3E8
ld de,#4000
ld bc,#3BE7
ldir

jp #40

load_files:
	;input a=index, hl=dest
	push hl
	ld b,8
	ld (filename+3),a
	ld hl,filename
	ld de,#c000
	call #bc77	;cas in open
	pop hl
	call #bc83	;cas in direct
	call #bc7a	;cas in close
ret


setscreen:
ld b,#bc:
ld a,8
	outloop:
	ld c,(hl):inc hl
	out (c),c
	inc b:res 1,b
	dec a:jr nz,outloop

	;xor a
	setinkloop:
		ld b,(hl):ld c,b
		inc hl
		push hl
		push af
		call #bc32
		pop af
		pop hl
		inc a
		cp 4
		jr nz,setinkloop
	ld bc,0
	jp #bc38
ret

clear:
ld (hl),0
ld d,h:ld e,l:inc de:ld bc,#3FFF
ldir
ret

wait:
ld a,180
halt
dec a
jr nz,$-2
ret



;111491
drawlogo:
call #bd19
ld hl,#c40f
ld hx,3
olop:
	ld lx,7
	ilop:
		call draw
		call draw
		inc hl
		dec lx:jr nz,ilop
	ld a,l:add 29:ld l,a
	dec hx:jr nz,olop
ret

draw:
ld a,(bc):inc bc
push bc
add a:add a:add a:ld e,a
ld b,8
	loop:
	ld a,(de)
	inc hl
	ld (hl),a
	rld
	dec l
	ld (hl),a
	inc hl:inc hl
	xor a:ld (hl),a
	dec l:dec l
	ld a,h:add 8:ld h,a
	inc e
	djnz loop
	ld a,h:add #c0:ld h,a
	inc hl:inc hl
	pop bc
	ret

outlist1:
db 6,25,1,32,2,#2a,7,#1e
db 0,25,15,3

silvuppo0:
db 2,2, 2,2, 2,2, 2,2, 2,2, 2,2, 2,2
db 2,2, 2,2, 2,2, 2,2, 2,2, 2,2, 2,2
db 2,2, 2,2, 2,2, 2,2, 2,2, 2,2, 2,2
;db 1,1, 1,1, 1,1, 1,1, 1,1, 1,1, 1,1
silvuppo:
db 2,0, 2,2, 5,6, 5,6, 5,6, 2,2, 2,2
db 2,2, 2,2, 2,2, 2,2, 2,2, 2,2, 2,2
db 1,1, 1,1, 4,3, 4,3, 4,3, 1,1, 0,1
leosoft:
db 2,0, 2,1, 5,6, 5,6, 5,6, 1,2, 2,2
db 2,0, 2,1, 2,2, 4,6, 2,2, 1,2, 0,2
db 1,1, 1,1, 4,3, 4,3, 4,3, 0,1, 0,1


align &100
parts:
db 0,0,0,0,0,0,0,0
db &FE,&FE,&FE,&FE,&FE,&FE,&FE,&00
db &FE,&FE,&FE,&FE,&FE,&FE,&FE,&FE
db &FE,&FE,&FC,&FC,&F8,&F0,&C0,&00
db &FE,&FE,&7E,&7E,&3E,&1E,&06,&00
db &06,&1E,&3E,&7E,&7E,&FE,&FE,&FE
db &C0,&F0,&F8,&FC,&FC,&FE,&FE,&FE


outlist2:
db 6,25,1,20,2,#24,7,#1e
db 0,8,17,4

filename:
db "PAU1.DAT"


warning:
db 15,1,31,13,9,7,24,#E7,#E7,24,31,11,1
db "= WARNING =",15,2,31,33,1
db "This game uses colour flipping. "
db "It works best on a",15,1," real CRT ",15,2,"(and"
db "wearing sunshades...) or with an"
db "emulator that offers ",15,1,34,"Interlaced"
db "Blending",34,15,2," (f.i. RVM)."
db 31,1,17
db "Be warned if you're sensitive to"
db 15,1,"flashing lights.",15,2," Sorry."
db 31,26,19,15,3,"- press a key -"
end_string equ $


lioncompressed:
db #01,#4A,#EE,#11,#44,#01,#1C,#AA,#FF,#BB,#EE,#01,#1B,#11,#FF,#FF,#FF,#FF,#88,#01,#1A,#33,#0F,#FF,#0F,#AF,#EE
db #01,#1A,#FE,#1E,#6F,#87,#0F,#7F,#88,#01,#18,#11,#9E,#5A,#2F,#A5,#4B,#1F,#CC,#01,#18,#11,#4F,#87,#2D,#2D,#96
db #1F,#CC,#01,#18,#67,#AD,#2D,#87,#87,#0F,#3F,#FF,#01,#18,#57,#1E,#4B,#A5,#96,#2D,#4B,#FF,#88,#01,#17,#AF,#8F
db #87,#0F,#0F,#4B,#87,#1F,#CC,#01,#17,#DF,#2D,#3F,#1F,#4F,#87,#0F,#87,#6E,#01,#16,#11,#AF,#87,#3F,#BF,#EF,#2D
db #2D,#3C,#3F,#01,#16,#11,#4F,#69,#FF,#6F,#7F,#0F,#4B,#87,#1F,#01,#16,#11,#AF,#87,#97,#3C,#1F,#1E,#0F,#4B,#0F
db #88,#01,#15,#11,#CF,#1E,#F0,#F0,#C3,#CF,#1E,#0F,#C3,#CC,#01,#15,#11,#8F,#B4,#F0,#F0,#F0,#6F,#C3,#2D,#0F,#88
db #01,#15,#77,#4F,#3C,#F0,#F0,#F0,#B7,#1E,#87,#E1,#4C,#01,#15,#67,#8F,#78,#F0,#F0,#F0,#D3,#4B,#2D,#0F,#6E,#01
db #15,#33,#0F,#F0,#F0,#F0,#F0,#D3,#0F,#1E,#87,#7F,#01,#15,#23,#8F,#B7,#78,#F0,#6F,#D3,#2D,#87,#2D,#FF,#01,#15
db #13,#1E,#C1,#F8,#F0,#BE,#F1,#4B,#3C,#0F,#7F,#88,#01,#14,#67,#1E,#E1,#F8,#F0,#BC,#F1,#2D,#0F,#4B,#7F,#CC,#01
db #14,#47,#1E,#F0,#F0,#F0,#F0,#F1,#1E,#5A,#2D,#7F,#CC,#01,#14,#47,#1E,#F0,#B4,#B4,#F0,#F1,#4B,#0F,#87,#FF,#CC
db #01,#14,#47,#1E,#F0,#B4,#B4,#F0,#F1,#2D,#A5,#4B,#FF,#BF,#01,#14,#8F,#1E,#F0,#78,#B4,#F0,#E3,#2D,#2D,#0F,#7F
db #DE,#FF,#EE,#01,#12,#47,#1E,#F0,#F0,#F0,#F0,#E3,#4B,#5A,#0F,#7F,#DE,#F0,#F1,#EE,#01,#11,#47,#0F,#E1,#F0,#3C
db #F0,#A7,#1E,#0F,#87,#7F,#DE,#F0,#F0,#F1,#FF,#EE,#01,#0F,#47,#0F,#5B,#FF,#DE,#78,#C7,#96,#2D,#0F,#7F,#DE,#F0
db #F0,#F0,#F0,#F1,#FF,#CC,#01,#0D,#8F,#0F,#A5,#FF,#AD,#B4,#8F,#A5,#1E,#0F,#7F,#EF,#F0,#F0,#F0,#F0,#F0,#F0,#F3
db #FF,#FF,#01,#0B,#8F,#0F,#5A,#7F,#5A,#5A,#AD,#0F,#A5,#0F,#3F,#EF,#78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#CC,#01
db #0A,#07,#0F,#2D,#A7,#A5,#B5,#4B,#5A,#0F,#0F,#7F,#EF,#B4,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F3,#01,#0A,#07,#0F
db #5A,#7A,#5A,#5B,#1E,#4B,#4B,#0F,#7F,#EF,#5A,#78,#F0,#E1,#78,#F0,#F0,#F0,#F0,#F0,#88,#01,#09,#47,#0F,#2D,#FF
db #A5,#A7,#5A,#2D,#0F,#0F,#6F,#EF,#0F,#A5,#B4,#3C,#F0,#F0,#F0,#F0,#F0,#F0,#C4,#01,#09,#27,#0F,#BF,#F0,#DE,#6F
db #87,#0F,#87,#0F,#7F,#FF,#0F,#5A,#4B,#78,#F0,#F0,#F0,#F0,#F0,#F0,#E2,#01,#09,#57,#4F,#FE,#F0,#E3,#CF,#2D,#4B
db #0F,#0F,#7F,#EF,#0F,#A5,#87,#F0,#F0,#F0,#F0,#F0,#A5,#A5,#B5,#01,#09,#23,#AF,#7E,#F0,#F1,#9E,#4B,#87,#0F,#2F
db #DF,#DF,#0F,#4B,#5A,#F0,#F0,#F0,#F0,#D2,#5A,#5A,#5A,#88,#01,#08,#33,#5F,#7F,#F0,#F7,#8F,#0F,#2D,#1F,#0F,#7F
db #CF,#0F,#0F,#0F,#F0,#F0,#F0,#F0,#A5,#A5,#A5,#A5,#C4,#01,#08,#23,#AF,#BF,#FF,#FF,#4B,#A5,#0F,#0F,#0F,#BF,#CF
db #0F,#0F,#1E,#F0,#F0,#F0,#F0,#5A,#5A,#4B,#1E,#6A,#01,#08,#33,#5F,#5F,#FF,#EF,#0F,#0F,#87,#0F,#9F,#7F,#CF,#0F
db #0F,#3C,#F0,#F0,#F0,#E1,#A5,#A5,#0F,#0F,#1F,#88,#01,#07,#33,#AF,#AF,#FF,#EF,#0F,#4B,#0F,#2F,#2F,#DF,#CF,#0F
db #0F,#3C,#F0,#F0,#F0,#F0,#5A,#4B,#0F,#0F,#0F,#4C,#01,#07,#11,#DF,#5F,#7F,#0F,#96,#0F,#0F,#0F,#5F,#FF,#CF,#0F
db #0F,#2D,#F0,#F0,#F0,#E1,#A5,#87,#0F,#0F,#0F,#2E,#01,#07,#11,#AF,#AF,#0F,#0F,#0F,#0F,#0F,#8F,#BF,#FF,#8F,#0F
db #0F,#0F,#F0,#F0,#F0,#D2,#5A,#0F,#0F,#0F,#0F,#2E,#01,#07,#77,#DF,#5F,#0F,#2D,#0F,#0F,#0F,#1F,#6F,#FF,#8F,#0F
db #0F,#1E,#F0,#F0,#F0,#E1,#A5,#0F,#0F,#0F,#0F,#1F,#01,#07,#77,#FF,#AF,#8F,#0F,#6F,#6F,#1F,#2F,#BF,#FF,#0F,#0F
db #0F,#1E,#F0,#F0,#F0,#D2,#5A,#0F,#0F,#0F,#0F,#0F,#88,#01,#06,#FF,#FF,#5F,#0F,#1E,#DF,#DF,#4F,#5F,#FF,#FF,#0F
db #0F,#0F,#1E,#F0,#F0,#F0,#E1,#A5,#0F,#0F,#0F,#0F,#0F,#88,#01,#06,#F9,#FF,#AF,#8F,#3F,#FF,#EF,#AF,#BF,#7F,#EF
db #0F,#0F,#0F,#AF,#F0,#F0,#F0,#D2,#4B,#0F,#0F,#0F,#0F,#0F,#88,#01,#05,#67,#D3,#FF,#DF,#4F,#7F,#FF,#DF,#7F,#FF
db #FF,#8F,#0F,#0F,#2F,#4F,#F0,#F0,#F0,#E1,#A5,#0F,#0F,#0F,#0F,#0F,#4C,#01,#04,#11,#F8,#C3,#7F,#FF,#8F,#EF,#FF
db #FF,#FF,#FF,#FF,#0F,#0F,#0F,#5F,#7F,#F0,#F0,#F0,#D2,#4B,#0F,#0F,#0F,#0F,#0F,#4C,#01,#04,#67,#F0,#E1,#BF,#FF
db #FF,#BC,#97,#FF,#FF,#FF,#EF,#0F,#0F,#0F,#AF,#FF,#F8,#F0,#F0,#E1,#A5,#0F,#0F,#0F,#0F,#0F,#4C,#01,#03,#33,#F8
db #F0,#E1,#3F,#EF,#BC,#F0,#F1,#FF,#FF,#FF,#CF,#0F,#0F,#1F,#FF,#FF,#F8,#F0,#F0,#F0,#5A,#0F,#0F,#0F,#0F,#0F,#4C
db #00,#00,#FF,#FC,#F0,#F0,#87,#7F,#0F,#F0,#F0,#E1,#FF,#FF,#DF,#1F,#3F,#8F,#7F,#FF,#FF,#BC,#F0,#F0,#F0,#A5,#87
db #0F,#0F,#0F,#0F,#4C,#00,#11,#F0,#F0,#F0,#E1,#0F,#1E,#3C,#F0,#F0,#E1,#BF,#AF,#CB,#DF,#4F,#E1,#D2,#4B,#FF,#FC
db #F0,#F0,#F0,#87,#0F,#0F,#0F,#0F,#0F,#4C,#00,#76,#F0,#F0,#A5,#0F,#0F,#78,#F0,#F0,#C3,#0F,#4F,#4F,#0F,#7F,#F8
db #5A,#A5,#A5,#A5,#96,#F0,#F0,#F0,#0F,#0F,#0F,#0F,#0F,#0F,#4C,#00,#F8,#F0,#E1,#C3,#0F,#3C,#F0,#F0,#F0,#C3,#0F
db #0F,#0F,#1F,#FF,#97,#8F,#D2,#5A,#5A,#69,#0F,#1E,#4B,#87,#0F,#0F,#0F,#0F,#8F,#4C,#11,#D2,#F0,#B4,#0F,#78,#F0
db #F0,#F0,#B4,#0F,#0F,#0F,#0F,#3F,#FF,#7F,#6F,#0F,#2D,#87,#0F,#2D,#A5,#87,#0F,#0F,#0F,#0F,#1F,#0F,#08,#33,#F0
db #D2,#D2,#96,#F0,#F0,#F0,#D2,#4B,#0F,#0F,#0F,#0F,#3F,#FF,#EF,#EF,#0F,#0F,#0F,#0F,#5A,#5A,#0F,#0F,#0F,#0F,#0F
db #EF,#0F,#00,#23,#FF,#8F,#AD,#FF,#F0,#F0,#F0,#4B,#2D,#0F,#0F,#0F,#0F,#7F,#CC,#11,#EF,#0F,#0F,#0F,#0F,#2D,#0F
db #FF,#8F,#0F,#0F,#7F,#0F,#2E,#00,#11,#FF,#FF,#FF,#EF,#F0,#F0,#B4,#A5,#0F,#0F,#0F,#0F,#0F,#7F,#88,#11,#CF,#0F
db #0F,#0F,#0F,#4B,#6F,#EF,#FF,#FF,#FF,#8F,#0F,#08,#01,#06,#12,#E1,#E1,#87,#1F,#88,#77,#CF,#7F,#11,#00,#00,#EF
db #0F,#0F,#0F,#0F,#1F,#FF,#BF,#CF,#0F,#0F,#0F,#1F,#88,#01,#06,#10,#F0,#B4,#3F,#01,#08,#33,#0F,#0F,#0F,#0F,#1F
db #BF,#FF,#4F,#0F,#0F,#0F,#6E,#01,#08,#11,#FF,#88,#01,#09,#77,#FF,#FF,#FF,#BB,#FF,#BF,#88,#FF,#FF,#FF,#88,#02




lion:
chord:
call #bca7
ld a,1
ld hl,env
call #bcbc
ld de,chords
setb:
	ld b,20
	halt
	djnz $-1
	ld b,3
	triadloop:
		ld a,(de)
		inc de
		ld (ton+3),a
		ld hl,ton
		push de
		push bc
		call #bcaa
		pop bc
		pop de
		djnz triadloop
	ld a,(ton)
	srl a
	ld (ton),a
	jr nz,setb
ret

ton:
db 4,1,0,000,0
db 0,15,70,0

env:
db 1,15,-1,8

chords:
db 159,169,253	;bass
db 106,95,84	;mid
db 63,56,50	;treble


len equ $-#3800
