;color masks:
COLOR_BROWN equ %0101
COLOR_RED 	equ	%0110
COLOR_ORANGE equ %0111
COLOR_BLUE 	equ %1001
COLOR_PURPLE equ %1010
COLOR_GREY equ %1011
COLOR_PINE equ %1101
COLOR_SHIT equ %1110
COLOR_GREEN equ %1111

align #200
_tiles:


; coding in compmap:
;
; 00-0F fg stat   16
; 10-1F fg norm   16
; 10-23 ld norm   04
; 24-3D bg norm   26
; 3E-3F extra1    02
;
; 40-4F bg stat   16 (1st empty)
; 50-5F fg mirr   16
; 60-63 ld mirr   04
; 64-7D bg mirr   26
; 7E-7F extra2    02
;
; compress:
;
; decompress:
; 1. if x and 3E==3E -> extra:
;     add #32
;     jp p,$+5
;         add #C0
; 2. if x>4F ->
;     xor #C0 (swap 2 top bits for mirror)
;
;
;
; coding in stagemap
; 00-0F fg stat   16
; 10-1F fg norm   16
; 20-23 ld norm   04
; 24-3D bg norm   26
; 3E-3F water, gas
; 40-4F bg stat   16
; 50-57 anim norm 08
; ??? 70-73 extra     04 (temp)
; 80-9F fg mirr   16
; A0-A3 ld mirr   04
; A4-BD bg mirr   26
; BE-BF fire, diamond
; D0-D7 anim mirr 08
; F0-FF combined  16

; max_solid = 1F
; min_bg    = 24
;
; gfx:
; 00-0F fg stat   16
; 10-1F fg norm   16
; 10-23 ld norm   04
; 24-3D bg norm   26
; 3E-40 #60 bytes available
; 40-4F bg stat   16 (1st void)
; 50-57 anim norm 08
; 58-67 items


_palette40:
db #54,#4C,#57,#56
_palettec0:
db #54,#40,#45,#5E
;		46

_palette_backup:
db #54,#4C,#57,#56
db #54,#40,#45,#5E


_tile_lines_offsets:
	db 1,11,-11,5,-3,3,-7,9

_vert_line_bitmaps:
db #22,#66,#66,#44

_menu_edge_bitmaps:
db #FF,#1f,#7f,#0F


incbin "pau_tiles.bin"



MENU_UPPER_ROW equ #4098

INVENTORY_SCRADR_1 equ #639F+85
INVENTORY_SCRADR_2 equ #43F5+85+86

BOOK_ITEMS_ORG equ #51a5+85
BOOK_POTION_SYM_ORG equ #799D+85
BOOK_SCRADDR equ #4144+85
POTION_ACTIVE_SYM_SCRADDR equ #54A0+86+86
POTION_TIMER_SCRADDR equ #44FB+86+86
LIVES_ICON_ORG equ #4E4F
LIVES_NUMBER_ORG equ #5652
GEMS_ICON_ORG equ #4E56
GEMS_NUMBER_ORG equ #5659

ALERT_BOX_ORG equ #5214
ALERT_BOX_SIZE equ #201E
ALERT_TEXT_ORG equ #526C

MENU_AMT_COLS equ 5
MENU_AMT_ROWS equ 3

_cursor_values:
;scraddr
	dw #70EE+85
	dw #53f3
	dw INVENTORY_SCRADR_2+#2Fa9
	dw MENU_UPPER_ROW+#2FA9
CURSOR_WIDTH equ 8
	dw 17,2,2,5				;in screenbytes
CURSOR_HEIGHT equ 16
	dw #21ae,#E056,#2000,#56	;offset to add to the address
CURSOR_COLS equ 24
CURSOR_MAX_COL equ 25
curr_potion_recipe:
	;first byte=last position, 2nd byte=max
	db 0,17		;potion book
	db 0,6		;inventory 1
	db 0,6		;inventory 2
	db 0,3		;top menu

_menu_hori_lines:
	dw #4041,#4143,#639D,#64F5,#55f7,#66A3


_book_item_syms:
	dw #51FA,#51FD,#6250,#6253,#72A6,#72A9
	db 0



_book_open:
  ;1,2,3-8,9,10, 11, 12,13,14-19,20,21
db #00,#70,#00,#00,#21,#0f,#48,#00,#00,#e0,#00
db #00,#87,#0f,#0f,#0f,#0f,#0f,#0f,#0f,#1e,#00
db #10,#0f,#ff,#cf,#0f,#0f,#0f,#3f,#ff,#0f,#80
db #10,#1f,#00,#33,#cf,#0f,#3f,#cc,#00,#8f,#80
db #10,#1f,#00,#00,#77,#0f,#ee,#00,#00,#8f,#80
db #00,#3f,#00,#00,#11,#9f,#88,#00,#00,#cf,#00
db #00,#3f,#00,#00,#00,#ff,#00,#00,#00,#cf,#00
_book_open_repeated_line:
db #00,#3f,#00,#00,#00,#66,#00,#00,#00,#cf,#00 ;46 times

db #00,#3f,#ff,#ff,#88,#66,#11,#ff,#ff,#cf,#00
db #10,#3f,#00,#00,#66,#66,#66,#00,#00,#cf,#80
db #10,#2e,#00,#00,#11,#66,#88,#00,#00,#47,#80
db #10,#3f,#ff,#ff,#ff,#ff,#ff,#ff,#ff,#cf,#80
db #00,#87,#0f,#0f,#0f,#0f,#0f,#0f,#0f,#1e,#00
db #00,#70,#00,#00,#21,#0f,#48,#00,#00,#e0,#00


_bomb_colors:
db #5C,#4C,#4e,#4a,#49,#4B,#5B,#53,#57,#55,#50,0


align #100
_ene_sprs:
incbin "pau_enemies.bin"


align #100
_pau_sprs:
incbin "pau_sprites.bin"
;#00-#47 	sprite for #40 screen
;#48-#90 	sprite for #c0 screen
;#90-#D7 	transparency masks
;-1		current orientation (0=right, -1=left)


_potion_symbols:
align #100
read "pau_symbols.asm"



_font:
db #00,#00,#00,#00,#00,#00
db #60,#60,#60,#60,#60,#60
db #00,#60,#60,#00,#60,#60
db #60,#60,#60,#60,#00,#60
db #00,#00,#00,#60,#60,#C0
db #3C,#66,#0C,#18,#00,#18
db #3C,#66,#66,#66,#66,#3C
db #18,#38,#18,#18,#18,#3C
db #3C,#66,#06,#3C,#60,#7E
db #3C,#66,#0C,#06,#66,#3C
db #1C,#3C,#6C,#6C,#7E,#0C
db #7E,#60,#7C,#06,#66,#3C
db #3C,#60,#7C,#66,#66,#3C
db #7E,#06,#06,#0C,#18,#18
db #3C,#66,#3C,#66,#66,#3C
db #3C,#66,#66,#3E,#06,#3C
db #3C,#66,#66,#7E,#66,#66
db #7C,#66,#7C,#66,#66,#7C
db #3C,#66,#60,#60,#66,#3C
db #7C,#66,#66,#66,#66,#7C
db #7E,#60,#7C,#60,#60,#7E
db #7E,#60,#7C,#60,#60,#60
db #3C,#66,#60,#6E,#66,#3E
db #66,#66,#7E,#66,#66,#66
db #06,#06,#06,#66,#66,#3C
db #66,#6C,#7C,#6C,#66,#66
db #60,#60,#60,#60,#60,#7E
db #42,#66,#7E,#66,#66,#66
db #66,#66,#76,#6E,#66,#66
db #3C,#66,#66,#66,#66,#3C
db #7C,#66,#66,#7C,#60,#60
db #3C,#66,#66,#6E,#66,#3E
db #7C,#66,#66,#7C,#6C,#66
db #3C,#66,#30,#0C,#66,#3C
db #7E,#18,#18,#18,#18,#18
db #66,#66,#66,#66,#66,#3C
db #66,#66,#66,#24,#3C,#18
db #66,#66,#66,#7E,#66,#42
db #66,#3C,#18,#3C,#66,#66
db #66,#66,#66,#3C,#18,#18
db #7E,#0C,#18,#30,#60,#7E
db #08,#0C,#7E,#7E,#0C,#08


_timer_bitmaps:
db #00,#08,#0C,#0E
